#ifndef DIGITAL_OUTPUT_H_
#define DIGITAL_OUTPUT_H_

class DigitalModule;

/**
 * Class to write to digital outputs.
 * Write values to the digital output channels. Other devices implemented elsewhere will allocate
 * channels automatically so for those devices it shouldn't be done here.
 */
class DigitalOutput : SensorBase
{
public:
	DigitalOutput(unsigned channel);
	DigitalOutput(unsigned slot, unsigned channel);
	~DigitalOutput(void);
	void Set(unsigned value);
	void Pulse(unsigned uSec);
	bool IsPulsing(void);

private:
	void InitDigitalOutput(unsigned slot, unsigned channel);

	unsigned m_channel;
	DigitalModule *m_module;
};

#endif
