#ifndef DIGITAL_SOURCE_H
#define DIGITAL_SOURCE_H

#include "InterruptableSensorBase.h"

/**
 * DigitalSource class.
 * The DigitalSource represents all the possible inputs for a counter or a quadrature encoder. The source may be
 * either a digital input or an analog input. If the caller just provides a channel, then a digital input will be
 * constructed and freed when finished for the source. The source can either be a digital input or analog trigger
 * but not both.
 */
class DigitalSource: public InterruptableSensorBase
{
public:
	virtual ~DigitalSource(void);
	virtual unsigned GetChannelForRouting(void)=0;
	virtual unsigned GetModuleForRouting(void)=0;
	virtual bool GetAnalogTriggerForRouting(void)=0;
	virtual void RequestInterrupts(tInterruptHandler handler) = 0;
	virtual void RequestInterrupts(void) = 0;
};

#endif

