#ifndef GEAR_TOOTH_H_
#define GEAR_TOOTH_H_

#include "CounterBase.h"

/**
 * Alias for counter class.
 * Implement the gear tooth sensor supplied by FIRST. Currently there is no reverse sensing on
 * the gear tooth sensor, but in future versions we might implement the necessary timing in the
 * FPGA to sense direction.
 */
class GearTooth : public Counter
{
public:
	/// 55 uSec for threshold
	static const unsigned kGearToothThreshold = 55;
	GearTooth(unsigned channel, bool directionSensitive = true);
	GearTooth(unsigned slot, unsigned channel, bool directionSensitive = true);
	GearTooth(DigitalSource *source, bool directionSensitive = true);
	~GearTooth(void);
private:
	void InitGTS(bool directionSensitive);
};


#endif
