#ifndef SERVO_H
#define SERVO_H

/**
 * Standard hobby style servo
 */
class Servo : public PWM
{
public:
	Servo(unsigned channel);
	Servo(unsigned slot, unsigned channel);
	virtual ~Servo(void);
	void Set(float value);
	float Get(void);
	void SetAngle(int angle);
	int GetAngle(void);

private:
	void InitServo(void);
	int GetServoAngleRange(void) {return kMaxServoAngle - kMinServoAngle;}

	static const int kMaxPwm = 245;
	static const int kMinPwm = 11;
	static const int kMaxServoAngle = 170;
	static const int kMinServoAngle = 0;
};

#endif

