#ifndef SPEED_CONTROLLER_H
#define SPEED_CONTROLLER_H

/**
 * Pure virtual base class for speed controlling devices.
 */
class SpeedController
{
public:
	/**
	 * Common interface for setting the speed of a speed controller.
	 * 
	 * @param speed The speed to set.  Value should be between -1.0 and 1.0.
	 */
	virtual void Set(float speed) = 0;
	/**
	 * Common interface for getting the current set speed of a speed controller.
	 * 
	 * @return The current set speed.  Value is between -1.0 and 1.0.
	 */
	virtual float Get(void) = 0;
};

#endif

