#ifndef TASK_H
#define TASK_H


/**
 * WPI task is a wrapper for the native Task object.
 * All WPI tasks are managed by a static task manager for simplified cleanup.
 **/
class Task {

public:
	
	Task(char* name, int priority );
	virtual ~Task();
	
	bool  Run();
	bool  Restart();
	bool  Kill();
	
	bool  Pause();
	bool  Resume();
	
	bool  Verify();
	
	int   GetPriority();
	void  SetPriority(int p);
	char* GetName();
	int   GetID();

private:
	char* m_taskName;
	int m_taskID;
	int m_taskPriority;
	
	
};

#endif
