#ifndef GENERIC_HID_H
#define GENERIC_HID_H

class GenericHID
{
public:
	typedef enum {
		kLeftHand = 0,
		kRightHand = 1
	} JoystickHand;

	virtual float GetX(JoystickHand hand = kRightHand) = 0;
	virtual float GetY(JoystickHand hand = kRightHand) = 0;
	virtual float GetZ(void) = 0;
	virtual float GetTwist(void) = 0;
	virtual float GetThrottle(void) = 0;
	virtual float GetRawAxis(unsigned axis) = 0;

	virtual bool GetTrigger(JoystickHand hand = kRightHand) = 0;
	virtual bool GetTop(JoystickHand hand = kRightHand) = 0;
	virtual bool GetBumper(JoystickHand hand = kRightHand) = 0;
	virtual bool GetRawButton(unsigned button) = 0;
};

#endif

