#ifndef __HiTechnicCompass_h__
#define __HiTechnicCompass_h__

#include "SensorBase.h"

class I2C;

/**
 * HiTechnic NXT Compass.
 * 
 * This class alows access to a HiTechnic NXT Compass on an I2C bus.
 * These sensors to not allow changing addresses so you cannot have more
 *   than one on a single bus.
 * 
 * Details on the sensor can be found here:
 *   http://www.hitechnic.com/index.html?lang=en-us&target=d17.html
 * 
 * @todo Implement a calibration method for the sensor.
 */
class HiTechnicCompass : public SensorBase
{
public:
	HiTechnicCompass(unsigned slot);
	virtual ~HiTechnicCompass();
	float GetAngle(void);

private:
	static const unsigned char kAddress = 0x02;
	static const unsigned char kManufacturerBaseRegister = 0x08;
	static const unsigned char kManufacturerSize = 0x08;
	static const unsigned char kSensorTypeBaseRegister = 0x10;
	static const unsigned char kSensorTypeSize = 0x08;
	static const unsigned char kHeadingRegister = 0x44;

	I2C* m_i2c;
};

#endif

