#ifndef INTERRUPTABLE_SENSORBASE_H_
#define INTERRUPTABLE_SENSORBASE_H_

#include "ChipObject.h"
#include "SensorBase.h"
#include <stdio.h>

class InterruptableSensorBase : public SensorBase
{
public:
	InterruptableSensorBase(void);
	virtual ~InterruptableSensorBase(void);
	virtual void RequestInterrupts(tInterruptHandler handler) = 0; ///< Asynchronus handler version.
	virtual void RequestInterrupts(void) = 0;		///< Synchronus Wait version.
	virtual void CancelInterrupts(void);			///< Free up the underlying chipobject functions.
	virtual void WaitForInterrupt(int msTimeout); ///< Synchronus version.
	virtual void EnableInterrupts(void);			///< Enable interrupts - after finishing setup.
	virtual void DisableInterrupts(void);		///< Disable, but don't deallocate.
protected:
	tInterrupt *m_interrupt;
	tInterruptManager *m_manager;
	unsigned m_interruptIndex;
	void AllocateInterrupts(bool watcher);
};

#endif

