#ifndef JAGUAR_H
#define JAGUAR_H

#include "PWM.h"
#include "SpeedController.h"

/**
 * Luminary Micro Jaguar Speed Control
 */
class Jaguar : public PWM, public SpeedController
{
public:
	Jaguar(unsigned channel);
	Jaguar(unsigned slot, unsigned channel);
	virtual ~Jaguar();
	float Get(void);
	void Set(float value);

private:
	void InitJaguar(void);

	static const int kMaxPwm = 255;
	static const int kCenterPwm = 128;
	static const int kMinPwm = 1;
};

#endif

