#ifndef PID_H_
#define PID_H_

#include "WPILib.h"

/**
 * Class implements a PID Control Loop.
 * 
 * On each "iteration" with new PID control values, call the CalcPWM() method
 * 
 * Implementation is currently incomplete -- does not yet have an implementation
 * for "integral" control.  (i.e. current this is just a PD control loop)
 */
class PID
{
private:
	float P_;			// factor for "proportional" control
	float I_;			// factor for "integral" control
	float D_;			// factor for "derivative" control
	float max_pwm_;		// maximum PWM value to provide as output from PID loop
	
	int prev_actual_;	// the prior actual sensor reading (used to compute velocity)
		
public:
	PID(float p, float i, float d, float max_pwm, int actual);
	~PID(void);
	float CalcPWM(int desired, int actual);
};

#endif
