#ifndef PID_SOURCE_H
#define PID_SOURCE_H

/**
 * PIDSource class is a generic sensor source for the PID class.
 * All sensors that can be used with the PID class will implement the PIDSource that
 * returns a standard value that will be used in the PID code.
 */
class PIDSource
{
public:
	virtual long PIDGet(void) = 0;
};

#endif
