// Copyright (c) National Instruments 2008.  All Rights Reserved.
// Do Not Edit... this file is generated!

#ifndef __AnalogTrigger_h__
#define __AnalogTrigger_h__

#include "tSystem.h"

namespace nFPGA
{
namespace n0BA6BBDC5CE760BA2A9A95D92CEA342A
{

class tAnalogTrigger : public tSystem
{
public:
   tAnalogTrigger(unsigned char sys_index, tRioStatusCode *status);
   ~tAnalogTrigger();

   static const unsigned char kNumSystems;

   static const unsigned int kSourceSelectAddresses [];
   static const unsigned int kUpperLimitAddresses [];
   static const unsigned int kLowerLimitAddresses [];

   typedef
   union{
      struct{
         unsigned InHysteresis : 1;
         unsigned OverLimit : 1;
         unsigned Rising : 1;
         unsigned Falling : 1;
      };
      struct{
         unsigned value : 4;
      };
   } tOutput;
   typedef
   union{
      struct{
         unsigned Channel : 3;
         unsigned Module : 1;
         unsigned Averaged : 1;
         unsigned Filter : 1;
      };
      struct{
         unsigned value : 6;
      };
   } tSourceSelect;

   void writeSourceSelect(tSourceSelect value, tRioStatusCode *status);
   void writeSourceSelect_Channel(unsigned char value, tRioStatusCode *status);
   void writeSourceSelect_Module(unsigned char value, tRioStatusCode *status);
   void writeSourceSelect_Averaged(bool value, tRioStatusCode *status);
   void writeSourceSelect_Filter(bool value, tRioStatusCode *status);
   tSourceSelect readSourceSelect(tRioStatusCode *status);
   unsigned char readSourceSelect_Channel(tRioStatusCode *status);
   unsigned char readSourceSelect_Module(tRioStatusCode *status);
   bool readSourceSelect_Averaged(tRioStatusCode *status);
   bool readSourceSelect_Filter(tRioStatusCode *status);

   void writeUpperLimit(signed int value, tRioStatusCode *status);
   signed int readUpperLimit(tRioStatusCode *status);

   void writeLowerLimit(signed int value, tRioStatusCode *status);
   signed int readLowerLimit(tRioStatusCode *status);


   static const unsigned char kNumOutputElements;
   static tOutput readOutput(unsigned char bitfield_index, tRioStatusCode *status);
   static bool readOutput_InHysteresis(unsigned char bitfield_index, tRioStatusCode *status);
   static bool readOutput_OverLimit(unsigned char bitfield_index, tRioStatusCode *status);
   static bool readOutput_Rising(unsigned char bitfield_index, tRioStatusCode *status);
   static bool readOutput_Falling(unsigned char bitfield_index, tRioStatusCode *status);




private:
   unsigned char _SystemIndex;

   #define AnalogTrigger_Output_ADDRESS 0x83E8

   #define AnalogTrigger0_SourceSelect_ADDRESS 0x8448
   #define AnalogTrigger0_UpperLimit_ADDRESS 0x8444
   #define AnalogTrigger0_LowerLimit_ADDRESS 0x8440

   #define AnalogTrigger1_SourceSelect_ADDRESS 0x843C
   #define AnalogTrigger1_UpperLimit_ADDRESS 0x8438
   #define AnalogTrigger1_LowerLimit_ADDRESS 0x8434

   #define AnalogTrigger2_SourceSelect_ADDRESS 0x8430
   #define AnalogTrigger2_UpperLimit_ADDRESS 0x842C
   #define AnalogTrigger2_LowerLimit_ADDRESS 0x8428

   #define AnalogTrigger3_SourceSelect_ADDRESS 0x8424
   #define AnalogTrigger3_UpperLimit_ADDRESS 0x8420
   #define AnalogTrigger3_LowerLimit_ADDRESS 0x841C

   #define AnalogTrigger4_SourceSelect_ADDRESS 0x8418
   #define AnalogTrigger4_UpperLimit_ADDRESS 0x8414
   #define AnalogTrigger4_LowerLimit_ADDRESS 0x8410

   #define AnalogTrigger5_SourceSelect_ADDRESS 0x840C
   #define AnalogTrigger5_UpperLimit_ADDRESS 0x83FC
   #define AnalogTrigger5_LowerLimit_ADDRESS 0x83F8

   #define AnalogTrigger6_SourceSelect_ADDRESS 0x8400
   #define AnalogTrigger6_UpperLimit_ADDRESS 0x8408
   #define AnalogTrigger6_LowerLimit_ADDRESS 0x8404

   #define AnalogTrigger7_SourceSelect_ADDRESS 0x83F4
   #define AnalogTrigger7_UpperLimit_ADDRESS 0x83F0
   #define AnalogTrigger7_LowerLimit_ADDRESS 0x83EC


};

}
}

#endif // __AnalogTrigger_h__
