// Copyright (c) National Instruments 2008.  All Rights Reserved.
// Do Not Edit... this file is generated!

#ifndef __DMA_h__
#define __DMA_h__

#include "tSystem.h"

namespace nFPGA
{
namespace n0BA6BBDC5CE760BA2A9A95D92CEA342A
{

class tDMA : public tSystem
{
public:
   tDMA(tRioStatusCode *status);
   ~tDMA();

   static const unsigned char kNumSystems;


   typedef
   union{
      struct{
         unsigned Pause : 1;
         unsigned Enable_AI0 : 1;
         unsigned Enable_AIAveraged0 : 1;
         unsigned Enable_AI1 : 1;
         unsigned Enable_AIAveraged1 : 1;
         unsigned Enable_Accumulator0 : 1;
         unsigned Enable_Accumulator1 : 1;
         unsigned Enable_DI : 1;
         unsigned Enable_AnalogTriggers : 1;
         unsigned Enable_Counters : 1;
         unsigned Enable_CounterTimers : 1;
         unsigned Enable_Encoders : 1;
         unsigned Enable_EncoderTimers : 1;
         unsigned ExternalClock : 1;
         unsigned ExternalClockSource_Channel : 4;
         unsigned ExternalClockSource_Module : 1;
         unsigned ExternalClockSource_AnalogTrigger : 1;
         unsigned RisingEdge : 1;
         unsigned FallingEdge : 1;
      };
      struct{
         unsigned value : 22;
      };
   } tConfig;


   static void writeRate(unsigned int value, tRioStatusCode *status);
   static unsigned int readRate(tRioStatusCode *status);

   static void writeConfig(tConfig value, tRioStatusCode *status);
   static void writeConfig_Pause(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_AI0(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_AIAveraged0(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_AI1(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_AIAveraged1(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_Accumulator0(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_Accumulator1(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_DI(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_AnalogTriggers(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_Counters(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_CounterTimers(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_Encoders(bool value, tRioStatusCode *status);
   static void writeConfig_Enable_EncoderTimers(bool value, tRioStatusCode *status);
   static void writeConfig_ExternalClock(bool value, tRioStatusCode *status);
   static void writeConfig_ExternalClockSource_Channel(unsigned char value, tRioStatusCode *status);
   static void writeConfig_ExternalClockSource_Module(unsigned char value, tRioStatusCode *status);
   static void writeConfig_ExternalClockSource_AnalogTrigger(bool value, tRioStatusCode *status);
   static void writeConfig_RisingEdge(bool value, tRioStatusCode *status);
   static void writeConfig_FallingEdge(bool value, tRioStatusCode *status);
   static tConfig readConfig(tRioStatusCode *status);
   static bool readConfig_Pause(tRioStatusCode *status);
   static bool readConfig_Enable_AI0(tRioStatusCode *status);
   static bool readConfig_Enable_AIAveraged0(tRioStatusCode *status);
   static bool readConfig_Enable_AI1(tRioStatusCode *status);
   static bool readConfig_Enable_AIAveraged1(tRioStatusCode *status);
   static bool readConfig_Enable_Accumulator0(tRioStatusCode *status);
   static bool readConfig_Enable_Accumulator1(tRioStatusCode *status);
   static bool readConfig_Enable_DI(tRioStatusCode *status);
   static bool readConfig_Enable_AnalogTriggers(tRioStatusCode *status);
   static bool readConfig_Enable_Counters(tRioStatusCode *status);
   static bool readConfig_Enable_CounterTimers(tRioStatusCode *status);
   static bool readConfig_Enable_Encoders(tRioStatusCode *status);
   static bool readConfig_Enable_EncoderTimers(tRioStatusCode *status);
   static bool readConfig_ExternalClock(tRioStatusCode *status);
   static unsigned char readConfig_ExternalClockSource_Channel(tRioStatusCode *status);
   static unsigned char readConfig_ExternalClockSource_Module(tRioStatusCode *status);
   static bool readConfig_ExternalClockSource_AnalogTrigger(tRioStatusCode *status);
   static bool readConfig_RisingEdge(tRioStatusCode *status);
   static bool readConfig_FallingEdge(tRioStatusCode *status);




private:
   unsigned char _SystemIndex;

   #define DMA_Rate_ADDRESS 0x815C
   #define DMA_Config_ADDRESS 0x8158


};

}
}

#endif // __DMA_h__
