/*----------------------------------------------------------------------------*/
/* Copyright (c) FIRST 2008. All Rights Reserved.							  */
/* Open Source Software - may be modified and shared by FRC teams. The code   */
/* must be accompanied by the FIRST BSD license file in $(WIND_BASE)/WPILib.  */
/*----------------------------------------------------------------------------*/

#ifndef _ERROR_H
#define _ERROR_H

#include "chipobject/NiRio.h"
#include <VxWorks.h>

/**
 * Error object represents a library error.
 */
class Error
{
public:
	Error(void);
	~Error(void);
	tRioStatusCode GetCode(void);
	const char *GetMessage(void);
	UINT32 GetLineNumber(void);
	void Clear(void);
	void Set(UINT32 code, char *message, UINT32 lineNumber);
private:
	tRioStatusCode m_code;
	char *m_message;
	UINT32 m_lineNumber;
};

#endif

