/*----------------------------------------------------------------------------*/
/* Copyright (c) FIRST 2008. All Rights Reserved.							  */
/* Open Source Software - may be modified and shared by FRC teams. The code   */
/* must be accompanied by the FIRST BSD license file in $(WIND_BASE)/WPILib.  */
/*----------------------------------------------------------------------------*/

#ifndef _ERROR_BASE_H
#define _ERROR_BASE_H

#include <VxWorks.h>
#include "ChipObject.h"

/**
 * Base class for most objects.
 * ErrorBase is the base class for most objects since it holds the generated error
 * for that object. In addition, there is a single instance of a global error object
 */
class ErrorBase
{
public:
	ErrorBase(void);
	virtual ~ErrorBase(void);
	UINT32 GetError( void );
	void ClearError(void);

protected:
	tRioStatusCode status;
	static tRioStatusCode globalError;
};

#endif
