/*----------------------------------------------------------------------------*/
/* Copyright (c) FIRST 2008. All Rights Reserved.							  */
/* Open Source Software - may be modified and shared by FRC teams. The code   */
/* must be accompanied by the FIRST BSD license file in $(WIND_BASE)/WPILib.  */
/*----------------------------------------------------------------------------*/

#ifndef JAGUAR_H
#define JAGUAR_H

#include "PWM.h"
#include "SpeedController.h"

/**
 * Luminary Micro Jaguar Speed Control
 */
class Jaguar : public PWM, public SpeedController
{
public:
	Jaguar(UINT32 channel);
	Jaguar(UINT32 slot, UINT32 channel);
	virtual ~Jaguar();
	void EnableDeadbandElimination(bool eliminateDeadband);
	float Get(void);
	void Set(float value);

private:
	void InitJaguar(void);

/*
 * Input profile defined by Luminary Micro.
 * 
 * Full reverse ranges from 0.671325ms to 0.6972211ms
 * Proportional reverse ranges from 0.6972211ms to 1.4482078ms
 * Neutral ranges from 1.4482078ms to 1.5517922ms
 * Proportional forward ranges from 1.5517922ms to 2.3027789ms
 * Full forward ranges from 2.3027789ms to 2.328675ms
 */

	static const INT32 kMaxPwm = 251;
	static const INT32 kDeadbandMaxPwm = 135;
	static const INT32 kCenterPwm = 128;
	static const INT32 kDeadbandMinPwm = 120;
	static const INT32 kMinPwm = 4;
};

#endif

