/*----------------------------------------------------------------------------*/
/* Copyright (c) FIRST 2008. All Rights Reserved.							  */
/* Open Source Software - may be modified and shared by FRC teams. The code   */
/* must be accompanied by the FIRST BSD license file in $(WIND_BASE)/WPILib.  */
/*----------------------------------------------------------------------------*/

#ifndef TASK_H
#define TASK_H

#include <taskLib.h>

/**
 * WPI task is a wrapper for the native Task object.
 * All WPI tasks are managed by a static task manager for simplified cleanup.
 **/
class Task
{
public:
	Task(char* name, INT32 priority);
	virtual ~Task();
	
	bool Run(FUNCPTR function, INT32 arg);
	bool Restart(void);
	bool Delete(void);
	
	bool Suspend(void);
	bool Resume(void);
	
	bool Verify(void);
	
	INT32 GetPriority(void);
	void SetPriority(INT32 priority);
	char* GetName(void);
	INT32 GetID(void);

private:
	char* m_taskName;
	INT32 m_taskID;
	INT32 m_priority;
	void HandleError();
	
};

#endif
