/********************************************************************************
*
*  Project   		: FIRST Motor Controller
*  Category 		: Team Deliverable Software (as source code) 	
*  Subsystem 		: FRC Vision for cRIO     			
* 
*  File Name  		: frcvtrack.h          
*  Contributors   	: ELF
*  Creation Date 	: August 12, 2008
*  Revision History	: Source code and revision history are maintained at
*                               	   sourceforge.WPI.edu  
*  
*  File Description	: Globally defined values for the FIRST Vision API
* 
*  API: Because the nivision.h uses C++ style comments, any file including this
*  must be a .cpp (not .c) - unless we find a compiler directive to override the
*  comment processing or to compile C as C++.
*                              
*/
/*----------------------------------------------------------------------------*/
/*        Copyright (c) FIRST 2008.  All Rights Reserved.                     */
/*  Open Source Software - may be modified and shared by FRC teams. The code  */
/*  must be accompanied by the FIRST BSD license file in $(WIND_BASE)/WPILib. */
/*----------------------------------------------------------------------------*/

#ifndef frcvtrack_h
#define frcvtrack_h

#include "baefrc_utilities.h"

/*  Tracking functions */

/* find a color in current camera image */

int frcFindColor(FrcHue color, FrcParticleAnalysisReport* trackReport);
int frcFindColor(const Range* hueRange, FrcParticleAnalysisReport *trackReport);
int frcFindColor(const Range* hueRange, int minSaturation, FrcParticleAnalysisReport *trackReport);
int frcFindColor(ColorMode mode, const Range* plane1Range, const Range* plane2Range, 
		const Range* plane3Range, FrcParticleAnalysisReport *trackReport);
int frcFindColor(ColorMode mode, const Range* plane1Range, const Range* plane2Range, 
		const Range* plane3Range, FrcParticleAnalysisReport *trackReport, FrcColorReport *colorReport);

/* track using camera based on template */
int frcFindColorFromTemplate(Image* templateImage);
/* Servo tracking support */
float frcComputeServoPosition(float normalizedValue);

#endif

